-- mein Mapviewer, anzeigen der PDA Map auf dem Bildschirm

mapviewer={};
mapviewer.moddir=g_currentModDirectory;

-- function mapviewer:load(xmlFile)
	-- debug
	-- print("mapviewer:load :" .. xmlFile);
-- end;

function mapviewer:loadMap(name)
	-- debug
	print(string.format("%s", g_i18n:getText("mapviewtxt")));
	local userXMLPath = Utils.getFilename("mapviewer.xml", mapviewer.moddir);
	local xmlFile = loadXMLFile("xmlFile", userXMLPath);

	self.mapvieweractive=false;
	self.maplegende = false;
	self.activePlayerNode=0;

	self.x=0;
	self.y=0;
	self.z=0;
	self.length=0;
	self.dX=0;
	self.dZ=0;
	self.l_PosY = 0;	--Legende Y Position
	self.TEntfernung=0;
	self.TRichtung=0;
	self.playerRotY=0;
	self.plyname = {};
	
	--Übersichtskarte
	--print("Laden der Übersichtskarte Daten");
	self.bigmap ={};
	self.bigmap.mapDimensionX = Utils.getNoNil(getXMLInt(xmlFile, "mapviewer.map#mapDimensionX"), 2048); --4096
	self.bigmap.mapDimensionY = Utils.getNoNil(getXMLInt(xmlFile, "mapviewer.map#mapDimensionY"), 2048); --4096
	self.bigmap.mapWidth = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map#mapWidth"), 1);  --1
	self.bigmap.mapHeight = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map#mapHeight"), 1);  --1 
	self.bigmap.mapPosX = 0.5-(self.bigmap.mapWidth/2);
	self.bigmap.mapPosY = 0.5-(self.bigmap.mapHeight/2);
	self.bigmap.mapTransp = 1;
	self.bigmap.OverlayId = nil
	self.bigmap.file = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map#file"), Utils.getFilename("gfx/pda_map.png", self.moddir)), self.moddir);
	self.bigmap.OverlayId = createImageOverlay(self.bigmap.file);
	--print(string.format("Datei für Karte geladen : %s", self.bigmap.file));
	--print("Laden der Übersichtskarte Daten beendet");
	
	--Map Legende
	--print("Laden der Legende Daten");
	self.bigmap.Legende = {};
	self.bigmap.Legende.OverlayId = nil
	self.bigmap.Legende.file = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.legende#file"), "gfx/background.png"), self.moddir);
	self.bigmap.Legende.OverlayId = createImageOverlay(self.bigmap.Legende.file);
	self.bigmap.Legende.width = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.legende#width"), 0.15);
	self.bigmap.Legende.height = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.legende#height"), 0.125);
	self.bigmap.Legende.legPosX = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.legende#posX"), 0.0244);
	self.bigmap.Legende.legPosY = 1-Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.legende#posY"), 0.15);
	--print(string.format("Datei für Karte geladen : %s", self.bigmap.Legende.file));
	--print("Laden der Legende Daten beendet");
	
	--Point of Interest
	self.usePoi = getXMLBool(xmlFile, "mapviewer.map.poi#usePoI");
	if self.usePoi then
		--print("Laden der PoI Daten");
		self.bigmap.PoI = {};
		self.bigmap.PoI.OverlayId = nil
		self.bigmap.PoI.file =Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.poi#file"), "gfx/PoI.png"), self.moddir);
		self.bigmap.PoI.OverlayId = createImageOverlay(self.bigmap.PoI.file);
		if self.bigmap.PoI.OverlayId == nil or self.bigmap.PoI.OverlayId == 0 then
			self.usePoi = false;
			print(g_i18n:getText("mapviewtxt") .. " : Kann 'PoI Overlay' nicht erzeugen, bitte Pfad und Dateinamen in der mapviewer.xml prüfen");
			print(g_i18n:getText("mapviewtxt") .. " : Could not Create PoI Overlay. Check path and filename in mapviewer.xml");
		end;
		self.bigmap.PoI.width = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.legende#width"), 1);
		self.bigmap.PoI.height = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.legende#height"), 1);
		self.bigmap.PoI.poiPosX = 0.5-(self.bigmap.PoI.width/2);
		self.bigmap.PoI.poiPosY = 0.5-(self.bigmap.PoI.height/2);
		--print(string.format("Datei für PoI geladen : %s", self.bigmap.PoI.file));
		--print("Laden der PoI Daten beendet");
	end;
	
	--Array für Fahrzeugkoordinaten
	--print("Laden der Fahrzeuge Daten");
	self.bigmap.IconSteerable = {};
	self.bigmap.IconSteerable.file = "";
	self.bigmap.IconSteerable.file = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.icons.iconSteerable#file"), "icons/tractor.png"), self.moddir);
	self.bigmap.IconSteerable.filemp = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.icons.iconSteerableCtrl#file"), "icons/tractorctrl.png"), self.moddir);
	--self.bigmap.PoI.file = 
	--Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.poi#file"), "gfx/PoI.png"), self.moddir);
	self.bigmap.IconSteerable.OverlayId = createImageOverlay(self.bigmap.IconSteerable.file);
	self.bigmap.IconSteerable.mpOverlayId = createImageOverlay(self.bigmap.IconSteerable.filemp);
	self.bigmap.IconSteerable.width = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map.icons.iconSteerable#width"), 0.0078125);
	self.bigmap.IconSteerable.height = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map.icons.iconSteerable#height"), 0.0078125);
	--print(string.format("Datei für Fahrzeuge geladen : %s", self.bigmap.IconSteerable.file));
	--print(string.format("Datei für Fahrzeuge MP geladen : %s", self.bigmap.IconSteerable.filemp));
	--print("Laden der Fahrzeuge Daten beendet");
	
	--Array für Anbauten
	--debug
	--print("Laden der Attacheable Daten");
	self.bigmap.IconAttachments = {};
	self.bigmap.IconAttachments.Icon = {front = {file = "", OverlayId = nil},rear={file = "", OverlayId = nil}};
	self.bigmap.IconAttachments.Icon.front.file = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.icons.iconAttachmentFront#file"), "icons/feldgeraet.png"), self.moddir);
	self.bigmap.IconAttachments.Icon.rear.file = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.icons.iconAttachmentRear#file"), "icons/feldgeraet.png"), self.moddir);
	self.bigmap.IconAttachments.Icon.front.OverlayId = createImageOverlay(self.bigmap.IconAttachments.Icon.front.file);
	self.bigmap.IconAttachments.Icon.rear.OverlayId = createImageOverlay(self.bigmap.IconAttachments.Icon.rear.file);
	self.bigmap.IconAttachments.width = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map.icons.iconAttachment#width"), 0.0078125);
	self.bigmap.IconAttachments.height = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map.icons.iconAttachment#height"), 0.0078125);
	--print(string.format("Datei für Attacheable front geladen : %s", self.bigmap.IconAttachments.Icon.front.file));
	--print(string.format("Datei für Attacheable rear geladen : %s", self.bigmap.IconAttachments.Icon.rear.file));
	--print("Laden der Attacheable Daten beendet");
	
	
	--Array für Spielerinfos
	--print("Laden der Spieler Daten");
	self.bigmap.player = {}; --
	self.bigmap.player.file = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.icons.iconPlayer#file"), "icons/eigenerspieler.png"), self.moddir);
	self.bigmap.player.filemp = Utils.getFilename(Utils.getNoNil(getXMLString(xmlFile, "mapviewer.map.icons.iconMPPlayer#file"), "icons/mpspieler.png"), self.moddir);
	-- self.bigmap.player.ArrowOverlayId = createImageOverlay(Utils.getFilename("icons/eigenerspieler.png", self.moddir));
	-- self.bigmap.player.mpArrowOverlayId = createImageOverlay(Utils.getFilename("icons/mpspieler.png", self.moddir));
	self.bigmap.player.ArrowOverlayId = createImageOverlay(self.bigmap.player.file);
	self.bigmap.player.mpArrowOverlayId = createImageOverlay(self.bigmap.player.filemp);
	self.bigmap.player.name = ""; 
	self.bigmap.player.xPos	= 0;
	self.bigmap.player.xPosPDA	= g_currentMission.missionPDA.pdaMapPosX;
	self.bigmap.player.yPos = 0;
	self.bigmap.player.yPosPDA = g_currentMission.missionPDA.pdaMapPosX;	
	-- self.bigmap.player.width = 24/self.bigmap.mapDimensionX;
	-- self.bigmap.player.height = 24/self.bigmap.mapDimensionY;
	self.bigmap.player.width = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map.icons.iconPlayer#width"), 0.0078125);
	self.bigmap.player.height = Utils.getNoNil(getXMLFloat(xmlFile, "mapviewer.map.icons.iconPlayer#height"), 0.0078125);
	--print(string.format("Datei für Spieler geladen : %s", self.bigmap.player.file));
	--print(string.format("Datei für Spieler MP geladen : %s", self.bigmap.player.filemp));
	--print("Laden der Spieler Daten beendet");
	
	--debug
	-- print("Name :" .. name);
	-- print("pdaMapPosX :" .. g_currentMission.missionPDA.pdaMapPosX);
	-- print("pdaMapPosY :" .. g_currentMission.missionPDA.pdaMapPosY);
	-- print("pdaCoordsXPos :" .. g_currentMission.missionPDA.pdaCoordsXPos);
	-- print("pdaCoordsYPos :" .. g_currentMission.missionPDA.pdaCoordsYPos);

end;

function mapviewer:deleteMap()
end;

function mapviewer:writeStream(streamId, connection)
end;

function mapviewer:readStream(streamId, connection)
end;

function mapviewer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function mapviewer:keyEvent(unicode, sym, modifier, isDown)
end;

function mapviewer:update(dt)
	if self.activePlayerNode == nil or self.activePlayerNode == 0 then
		if g_currentMission.player ~= nil then
			self.activePlayerNode=g_currentMission.player.rootNode;
		end;
	end;
	-- Taste für Map anzeigen
	if InputBinding.hasEvent(InputBinding.BIGMAP_Activate) then
		self.mapvieweractive=not self.mapvieweractive;
	end;
	--Taste für Legende einblenden
	if InputBinding.hasEvent(InputBinding.BIGMAP_Legende) then
		if self.mapvieweractive then
			--Legende einblenden
			self.maplegende = not self.maplegende;
		end;
	end;
	--BigMap Transparenz erhöhen und verringern
	if InputBinding.hasEvent(InputBinding.BIGMAP_TransPlus) then
		if self.bigmap.mapTransp < 1 then
			self.bigmap.mapTransp = self.bigmap.mapTransp + 0.05;
		end;
	end;
	if InputBinding.hasEvent(InputBinding.BIGMAP_TransMinus) then
		if self.bigmap.mapTransp > 0.1 then
			self.bigmap.mapTransp = self.bigmap.mapTransp - 0.05;
		end;
	end;
end;

function mapviewer:draw()
	if self.mapvieweractive then
		if self.bigmap.OverlayId ~=nil then
			setOverlayColor(self.bigmap.OverlayId, 1,1,1,self.bigmap.mapTransp);
			renderOverlay(self.bigmap.OverlayId, self.bigmap.mapPosX, self.bigmap.mapPosY, self.bigmap.mapWidth, self.bigmap.mapHeight);			
		else
			print(g_i18n:getText("mapviewtxt") .. " : Kann 'self.bigmap.OverlayId' nicht erzeugen");
			print(g_i18n:getText("mapviewtxt") .. " : Could not Create Map Overlay");
		end;
		if self.mapvieweractive and not self.maplegende then
			g_currentMission:addHelpButtonText(g_i18n:getText("BIGMAP_Legende"), InputBinding.BIGMAP_Legende);
			g_currentMission:addHelpButtonText(g_i18n:getText("BIGMAP_TransPlus"), InputBinding.BIGMAP_TransPlus);
			g_currentMission:addHelpButtonText(g_i18n:getText("BIGMAP_TransMinus"), InputBinding.BIGMAP_TransMinus);
			--g_currentMission:addHelpButtonText(string.format("Transparenz\t%d", self.bigmap.mapTransp * 100), "");
			setTextColor(1, 1, 1, 1);
			renderText(0.5-0.0273, 1-0.03, 0.018, string.format("Transparenz\t%d", self.bigmap.mapTransp * 100));
			--Copyright
			renderText(0.5-0.035, 0.06, 0.018, g_i18n:getText("mapviewtxt"));
			setTextColor(1, 1, 1, 0);
		end;
		if self.maplegende then
			if self.usePoi then
				if self.bigmap.PoI.OverlayId ~= nil and self.bigmap.PoI.OverlayId ~= 0 then
					renderOverlay(self.bigmap.PoI.OverlayId, self.bigmap.PoI.poiPosX, self.bigmap.PoI.poiPosY, self.bigmap.PoI.width, self.bigmap.PoI.height);
				else
					print(g_i18n:getText("mapviewtxt") .. " : Kann 'PoI Overlay' nicht erzeugen");
					print(g_i18n:getText("mapviewtxt") .. " : Could not Create PoI Overlay");
				end;
			end;
			-- if self.usePoi and self.bigmap.PoI.OverlayId ~= nil then
				-- renderOverlay(self.bigmap.PoI.OverlayId, self.bigmap.PoI.poiPosX, self.bigmap.PoI.poiPosY, self.bigmap.PoI.width, self.bigmap.PoI.height);
			-- elseif self.bigmap.PoI.OverlayId == nil then
				-- print(g_i18n:getText("mapviewtxt") .. " : Kann 'PoI Overlay' nicht erzeugen");
				-- print(g_i18n:getText("mapviewtxt") .. " : Could not Create PoI Overlay");
			-- end;
			if self.bigmap.Legende.OverlayId ~=nil then
				renderOverlay(self.bigmap.Legende.OverlayId, self.bigmap.Legende.legPosX, self.bigmap.Legende.legPosY, self.bigmap.Legende.width, self.bigmap.Legende.height);
				setTextColor(0, 0, 0, 1);
				--Legende erstellen
				self.l_PosY = 1-0.02441 - 0.007324 - 0.015625; -- 1-50-15-32
				--Eigener Spieler Icon
				renderOverlay(self.bigmap.player.ArrowOverlayId,
								self.bigmap.Legende.legPosX + 0.007324,
								self.l_PosY, 
								0.015625, 
								0.015625);
				renderText(self.bigmap.Legende.legPosX + 0.029297, self.l_PosY, 0.012, "Eigener Spieler auf Karte");
				--Andere Spieler Icon
				self.l_PosY = self.l_PosY - 0.020;
				renderOverlay(self.bigmap.player.mpArrowOverlayId,
								self.bigmap.Legende.legPosX + 0.007324,
								self.l_PosY,
								0.015625, 
								0.015625);
				renderText(self.bigmap.Legende.legPosX + 0.029297, self.l_PosY, 0.012, "Andere Spieler auf Karte");
				--Spieler auf Fahrzeug
				self.l_PosY = self.l_PosY - 0.020;
				renderOverlay(self.bigmap.IconSteerable.mpOverlayId,
								self.bigmap.Legende.legPosX + 0.007324,
								self.l_PosY,
								0.015625, 
								0.015625);
				renderText(self.bigmap.Legende.legPosX + 0.029297, self.l_PosY, 0.012, "Andere Spieler im Fahrzeug");
				--Leere Fahrzeug
				self.l_PosY = self.l_PosY - 0.020;
				renderOverlay(self.bigmap.IconSteerable.OverlayId,
								self.bigmap.Legende.legPosX + 0.007324,
								self.l_PosY,
								0.015625, 
								0.015625);
				renderText(self.bigmap.Legende.legPosX + 0.029297, self.l_PosY, 0.012, "Leere Fahrzeuge auf Karte");
				--Anbaugeräte, Anhänger
				self.l_PosY = self.l_PosY - 0.020;
				renderOverlay(self.bigmap.IconAttachments.Icon.front.OverlayId,
								self.bigmap.Legende.legPosX + 0.007324,
								self.l_PosY,
								0.015625, 
								0.015625);
				renderText(self.bigmap.Legende.legPosX + 0.029297, self.l_PosY, 0.012, "Anbaugeräte und Anhänger");
				setTextColor(1, 1, 1, 0);
			end;
		elseif self.bigmap.Legende.OverlayId == nil then
			renderText(self.bigmap.Legende.legPosX + 0.029297, self.l_PosY, 0.012, "Rendern der Legende Fehlgeschlagen");
			print(g_i18n:getText("mapviewtxt") .. " : Rendern der Maplegende fehlgeschlagen");
			print(g_i18n:getText("mapviewtxt") .. " : Error rendering map legend");
		end;

		mplayer = {};
		for key, value in pairs (g_currentMission.players) do
			mplayer.player = value;
			if mplayer.player.isControlled == false then
				posX = mplayer.player.lastXPos;
				posY = mplayer.player.lastYPos;
				posZ = posY;
			else
				posX, posY, posZ = getWorldTranslation(mplayer.player.rootNode);
			end;

			mplayer.xPos = ((((self.bigmap.mapDimensionX/2)+posX)/self.bigmap.mapDimensionX)*self.bigmap.mapWidth);--self.bigmap.player.xPosPDA+0.008;
			mplayer.yPos = ((((self.bigmap.mapDimensionY/2)-posZ)/self.bigmap.mapDimensionY)*self.bigmap.mapHeight);--self.bigmap.player.yPosPDA+0.003;
			setTextColor(0, 1, 0, 1);

			if mplayer.player.rootNode == self.activePlayerNode and mplayer.player.isControlled then
				if self.bigmap.player.ArrowOverlayId ~= nil and self.bigmap.player.ArrowOverlayId ~= 0 then
					renderOverlay(self.bigmap.player.ArrowOverlayId, 
								mplayer.xPos-self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2,
								self.bigmap.player.width, self.bigmap.player.height);
				end;
				renderText(mplayer.xPos +self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2, 0.015, mplayer.player.controllerName);
				renderText(0.020, 0.020, 0.015, string.format("Koordinaten : x%.1f / y%.1f",mplayer.xPos*1000,mplayer.yPos*1000));
				--renderText(0.020, 0.040, 0.015, string.format("Koordinaten : x=%.3f / y=%.3f",mplayer.xPos,mplayer.yPos));
			elseif mplayer.player.isControlled then
				if self.bigmap.player.mpArrowOverlayId ~=nil and self.bigmap.player.mpArrowOverlayId ~= 0 then
					renderOverlay(self.bigmap.player.mpArrowOverlayId, 
								mplayer.xPos-self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2, 
								self.bigmap.player.width, self.bigmap.player.height);
				end;
				renderText(mplayer.xPos +self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2, 0.015, mplayer.player.controllerName);
			end;
			setTextColor(1, 1, 1, 0);
		end;
		
		--Hotspots auf grosse Karte
		for j=1, table.getn(g_currentMission.missionPDA.hotspots) do
			self.hsWidth = g_currentMission.missionPDA.hotspots[j].width;
			self.hsHeight = g_currentMission.missionPDA.hotspots[j].height;
			self.hsPosX = (g_currentMission.missionPDA.hotspots[j].xMapPos/self.bigmap.mapDimensionX)-(self.hsWidth/2);
			self.hsPosY = 1-(g_currentMission.missionPDA.hotspots[j].yMapPos/self.bigmap.mapDimensionY);--self.hsHeight;
			self.hsOverlayId = g_currentMission.missionPDA.hotspots[j].overlay.overlayId;
			renderOverlay(self.hsOverlayId, self.hsPosX, self.hsPosY, self.hsWidth, self.hsHeight);
				--debug
				-- print("Index HotSpots erzeugen:" .. j);
				-- print("self.hsWidth :" .. self.hsWidth);
				-- print("self.hsHeight :" .. self.hsHeight);
				-- print("self.hsPosX :" .. self.hsPosX);
				-- print("self.hsPosY :" .. self.hsPosY);
				-- print("self.hsOverlayId :" .. self.hsOverlayId);
		end;

		-- Fahrzeuge auf grosse Karte
		for i=1, table.getn(g_currentMission.steerables) do
			if not g_currentMission.steerables[i].isBroken then
				self.currentVehicle = g_currentMission.steerables[i];
				self.posX, self.posY, self.posZ = getWorldTranslation(self.currentVehicle.rootNode);
				self.buttonX = ((((self.bigmap.mapDimensionX/2)+self.posX)/self.bigmap.mapDimensionX)*self.bigmap.mapWidth);
				self.buttonZ = ((((self.bigmap.mapDimensionY/2)-self.posZ)/self.bigmap.mapDimensionY)*self.bigmap.mapHeight);
				
				setTextColor(0, 1, 0, 1);
				if self.currentVehicle.isControlled and self.currentVehicle.controllerName == self.plyname.name then
					if self.bigmap.IconSteerable.mpOverlayId ~= nil and self.bigmap.IconSteerable.mpOverlayId ~= 0 then
						renderOverlay(self.bigmap.IconSteerable.mpOverlayId,
									self.buttonX-self.bigmap.IconSteerable.width/2, 
									self.buttonZ-self.bigmap.IconSteerable.height/2,
									self.bigmap.IconSteerable.width,
									self.bigmap.IconSteerable.height);
						setOverlayColor(self.bigmap.IconSteerable.OverlayId, 1, 1, 1, 1);
					end;
					
					renderText(self.buttonX-0.025, self.buttonZ-self.bigmap.IconSteerable.height-0.01, 0.015, string.format("%s", self.plyname.name));
					renderText(0.020, 0.020, 0.015, string.format("Koordinaten : x=%.1f / y=%.1f",self.buttonX * 1000,self.buttonZ * 1000));
				elseif self.currentVehicle.isControlled then
					if self.bigmap.IconSteerable.mpOverlayId ~= nil and self.bigmap.IconSteerable.mpOverlayId ~= 0 then
						renderOverlay(self.bigmap.IconSteerable.mpOverlayId,
									self.buttonX-self.bigmap.IconSteerable.width/2, 
									self.buttonZ-self.bigmap.IconSteerable.height/2,
									self.bigmap.IconSteerable.width,
									self.bigmap.IconSteerable.height);
						setOverlayColor(self.bigmap.IconSteerable.OverlayId, 1, 1, 1, 1);
					end;
					renderText(self.buttonX-0.025, self.buttonZ-self.bigmap.IconSteerable.height-0.01, 0.015, string.format("%s", self.currentVehicle.controllerName));
				else
					if self.bigmap.IconSteerable.OverlayId ~= nil and self.bigmap.IconSteerable.OverlayId ~= 0 then
						renderOverlay(self.bigmap.IconSteerable.OverlayId,
									self.buttonX-self.bigmap.IconSteerable.width/2, 
									self.buttonZ-self.bigmap.IconSteerable.height/2,
									self.bigmap.IconSteerable.width,
									self.bigmap.IconSteerable.height);
						setOverlayColor(self.bigmap.IconSteerable.OverlayId, 1, 1, 1, 1);
					end;
				end;
				setTextColor(1, 1, 1,0);
			end;
		end;
		-----
		for i=1, table.getn(g_currentMission.attachables) do
			self.currentVehicle = g_currentMission.attachables[i];
			self.posX, self.posY, self.posZ = getWorldTranslation(self.currentVehicle.rootNode);
			self.buttonX = ((((self.bigmap.mapDimensionX/2)+self.posX)/self.bigmap.mapDimensionX)*self.bigmap.mapWidth);
			self.buttonZ = ((((self.bigmap.mapDimensionY/2)-self.posZ)/self.bigmap.mapDimensionY)*self.bigmap.mapHeight);
				renderOverlay(self.bigmap.IconAttachments.Icon.front.OverlayId,
								self.buttonX-self.bigmap.IconAttachments.width/2, 
								self.buttonZ-self.bigmap.IconAttachments.height/2,
								self.bigmap.IconAttachments.width,
								self.bigmap.IconAttachments.height);
				setOverlayColor(self.bigmap.IconAttachments.Icon.front.OverlayId, 1, 1, 1, 1);
		end;
		-----
	end;
	--Namen auf PDA anzeigen
		self.plyname.name = g_currentMission.player.controllerName;
		self.plyname.yPos = g_currentMission.missionPDA.pdaPlayerMapArrow.y - 0.003;
		self.plyname.xPos = g_currentMission.missionPDA.pdaPlayerMapArrow.x;
	if g_currentMission.missionPDA.showPDA == true and g_currentMission.missionPDA.screen==1 then
		setTextColor(256,256,256,1);
		setTextAlignment(RenderText.ALIGN_CENTER);
		renderText(self.plyname.xPos, self.plyname.yPos, 0.02, self.plyname.name);
		setTextAlignment(RenderText.ALIGN_LEFT);
	end;
	---------------------------
end;

addModEventListener(mapviewer);